<template>
  <div>

    <el-form ref="form" :rules="rules" :model="form" label-width="100px">
      <headerTitle title="基本信息"></headerTitle>
      <el-row :gutter="12">
        <el-col :span="12">
          <el-form-item
            label="申请部门"
            prop="applyDeptId"
            style="margin-bottom: 22px"
          >
            <ele-tree-select
              clearable
              :data="deptTreeList"
              v-model="form.applyDeptId"
              valueKey="id"
              labelKey="name"
              placeholder="请选择"
              @change="changeDeptInfo"
              default-expand-all
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item
            label="申请人"
            prop="applyUserId"
            style="margin-bottom: 22px"
          >
            <personSelect
              ref="directorRef"
              v-model="form.applyUserId"
              @selfChange="changeUserInfo"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="12">
        <el-col :span="12">
          <el-form-item
            label="费用类型"
            prop="feeTypeId"
            style="margin-bottom: 22px"
          >
            <ele-tree-select
              clearable
              filterable
              ref="feeTypeTree"
              :data="feeTypeList"
              v-model="form.feeTypeId"
              valueKey="id"
              labelKey="name"
              placeholder="请选择"
              @change="changeFeeTypeInfo"
              default-expand-all
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item
            label="金额"
            prop="amount"
            style="margin-bottom: 22px">
            <el-input-number v-model="form.amount" :precision="2" :controls="false" style="width: 100%"
                             :min="0"></el-input-number>
          </el-form-item>
        </el-col>
      </el-row>
      <!--        <el-col :span="12">-->
      <!--          <el-form-item-->
      <!--            label="会计科目"-->
      <!--            prop="accountingSubjectId"-->
      <!--            style="margin-bottom: 22px"-->
      <!--          >-->
      <!--            <ele-tree-select-->
      <!--              clearable-->
      <!--              filterable-->
      <!--              ref="treeSelect"-->
      <!--              :data="accountingSubjectList"-->
      <!--              v-model="form.accountingSubjectId"-->
      <!--              valueKey="id"-->
      <!--              labelKey="name"-->
      <!--              placeholder="请选择"-->
      <!--              @change="changeSubjectInfo"-->
      <!--              default-expand-all-->
      <!--            />-->
      <!--          </el-form-item>-->
      <!--        </el-col>-->

      <el-row :gutter="12">
        <el-col :span="24">
          <el-form-item
            label="备注"
            style="margin-bottom: 22px">
            <el-input v-model="form.remark" type="textarea" clearable></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="12">
        <el-col :span="12">
          <el-form-item prop="repliedFiles" label="附件">
            <fileUpload
              v-model="form.files"
              module="main"
              :showLib="false"
              :limit="10"
            />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <headerTitle title="关联信息"></headerTitle>
    <fee-related-info-table ref="feeRelatedInfoTable" v-if="form.link.length||dialogType=='add'" :link.sync="form.link"></fee-related-info-table>
  </div>
</template>
<script>
import personSelect from "@/components/CommomSelect/person-select.vue";
import {listOrganizations} from "@/api/system/organization";
import {mapGetters} from "vuex";
import fileUpload from "@/components/upload/fileUpload.vue";
import {
  feeApplyUpdateAPI,
  getFeeApplyInfoAPI
} from "@/api/bpm/components/financialManage/fee-manage/fee-application";
import {getTreeByPid} from "@/api/classifyManage";
import {getTableList} from '@/api/bpm/components/saleManage/quotation';
import {getFile} from "@/api/system/file";
import feeRelatedInfoTable from "@/views/bpm/handleTask/components/financialManage/components/feeRelatedInfoTable.vue";

export default {
  name: "add-or-edit-dialog",
  components: {
    fileUpload,
    personSelect,
    feeRelatedInfoTable
  },
  computed: {
    ...mapGetters(['user'])
  },
  props: {
    businessId: {
      default: ''
    },
    taskDefinitionKey:{
      default: ''
    },
  },
  data() {
    return {
      contractListDialogFlag: false,
      customerListDialogFlag: false,
      dialogType: '',
      title: '',
      form: {
        id: '',
        accountingSubjectId: '',
        accountingSubjectCode: '',
        accountingSubjectName: "",
        amount: undefined,
        applyDeptId: '',
        applyDeptName: "",
        applyUserId: '',
        applyUserName: "",
        feeTypeId: '',
        feeTypeName: "",
        feeTypeCode: "",
        files: [],
        remark: '',
        link: [],
      },
      feeTypeList: [],
      accountingSubjectList: [],
      deptList: [],
      deptTreeList: [],
      rules: {
        applyDeptId: {required: true, message: '请选择', trigger: 'change'},
        applyUserId: {required: true, message: '请选择', trigger: 'change'},
        // accountingSubjectId: {required: true, message: '请选择', trigger: 'change'},
        feeTypeId: {required: true, message: '请选择', trigger: 'change'},
        amount: {required: true, message: '请输入', trigger: 'blur'},
      }
    }
  },
  created() {
    this.init()
  },
  methods: {
    //初始化
    async init(row = {}, type) {
      await this.getClassifyList(25, 'feeTypeList')
      await this.getClassifyList(24, 'accountingSubjectList')
      await this.getDeptList()
      await this.getFeeApplyInfoInfo(this.businessId)
      this.$nextTick(async () => {
        await this.getUserList(this.form.applyDeptId);
      })
    },
    //获取详情
    async getFeeApplyInfoInfo(id) {
      this.form = await getFeeApplyInfoAPI(id)
    },
    downloadFile(file) {
      getFile({objectName: file.storePath}, file.name);
    },
    //获取分类管理中的数据
    async getClassifyList(id, listName) {
      let res = await getTreeByPid(id)
      this[listName] = res.data
    },
    //获取费用类别选中数据
    changeFeeTypeInfo(val) {
      if (!val) {
        this.form.feeTypeName = ''
        this.form.feeTypeCode = ''
      }
      let data = this.$refs.feeTypeTree?.$refs?.tree?.getCurrentNode() || {}
      this.form.feeTypeName = data.name
      this.form.feeTypeCode = data.code
    },
    //获取会计科目选中数据
    changeSubjectInfo(val) {
      if (!val) return this.form.accountingSubjectName = ''
      let data = this.$refs.treeSelect?.$refs?.tree?.getCurrentNode() || {}
      this.form.accountingSubjectName = data.name
    },
    // 获取部门数据
    getDeptList() {
      listOrganizations().then((list) => {
        this.deptList = list;
        this.deptTreeList = this.$util.toTreeData({
          data: list,
          idField: 'id',
          parentIdField: 'parentId'
        });
      });
    },
    // 选择负责人部门
    changeDeptInfo(id) {
      const info = this.deptList.find((e) => e.id == id) || {};
      this.form.applyDeptName = info.name;
      this.form.applyUserId = '';
      this.form.applyUserName = '';
      this.getUserList(id);
    },
    // 获取人员数据
    getUserList(deptId) {
      if (deptId) {
        this.$refs.directorRef.getList({deptId});
      }
    },
    //选择人员数据
    changeUserInfo(val, info) {
      this.form.applyUserName = info.name;
    },
    //
    getTableValue() {
      return new Promise((resolve) => {
        this.$refs.form.validate(async valid => {
          if (!valid) return this.$message.warning('有必填项未填，请检查')
          this.form.link = await this.$refs.feeRelatedInfoTable.getTableValidate()
          const API = feeApplyUpdateAPI
          const id = await API(this.form)
          resolve(id)
        })
      })
    },
  }
}
</script>
<style scoped lang="scss">

</style>
